;;; This file is part of nanolisp, a very small Lisp system.

;;; Copyright (C) 2007  Luca Saiu

;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.

;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.

;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(define interval
  (lambda (a b)
    (if (> a b)
        '()
        (cons a (interval (+ a 1) b)))))

(define for-all?
  (lambda (predicate list)
    (if (null? list)
        #t
        (if (predicate (car list))
            (for-all? predicate (cdr list))
            #f))))

(define not
  (lambda (b)
    (if b #f #t)))

(define prime?
  (lambda (n)
    (for-all? (lambda (i)
                (not (= (remainder n i) 0)))
              (interval 2 (- n 1)))))

(define print-all-primes
  (lambda ()
    (print-primes-starting-from 2)))

(define print-primes-starting-from
  (lambda (n)
    (if (prime? n)
        (begin
          (display n)
          (newline))
        #t)
    (print-primes-starting-from (+ n 1))))

(print-all-primes)
